/*
 *  Headers for regex.c
 *
 *  Copyright (C) 2000 Jens Laas jens.laas@data.slu.se
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

struct regex {
  struct expart *head;
  char *start;
};

struct expart {
  int type;
  int sign;
  struct regex *regex;
  int enumeration;           /*  ?, +, *  */
  struct expart *subparts;   /* (a|b|..) */
  int nr_subparts;
  char *sub_string;
  char *map;                 /* 256  bytes map. Used in [a-zMN0-9] */
  char c;                    /* atomic, this char must match */
  struct expart *next;
};
typedef struct expart expart;

struct regex *regex( char *string );

int query( struct regex *regex, char *string );

enum { MODE_GREP, MODE_EGREP };
